install-sgx-psw.bin.tmpl 3.2 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110
  1. #!/usr/bin/env bash
  2. #
  3. # Copyright (C) 2011-2016 Intel Corporation. All rights reserved.
  4. #
  5. # Redistribution and use in source and binary forms, with or without
  6. # modification, are permitted provided that the following conditions
  7. # are met:
  8. #
  9. # * Redistributions of source code must retain the above copyright
  10. # notice, this list of conditions and the following disclaimer.
  11. # * Redistributions in binary form must reproduce the above copyright
  12. # notice, this list of conditions and the following disclaimer in
  13. # the documentation and/or other materials provided with the
  14. # distribution.
  15. # * Neither the name of Intel Corporation nor the names of its
  16. # contributors may be used to endorse or promote products derived
  17. # from this software without specific prior written permission.
  18. #
  19. # THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  20. # "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  21. # LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  22. # A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  23. # OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  24. # SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  25. # LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  26. # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  27. # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  28. # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  29. # OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  30. #
  31. #
  32. modinfo isgx &> /dev/null
  33. if [[ $? != "0" ]]; then
  34. echo "Please install the driver package before the PSW package"
  35. exit 4
  36. fi
  37. set -e
  38. PKG_NAME="Intel SGX PSW Package"
  39. if test $(id -u) -ne 0; then
  40. echo "Root privilege is required to install $PKG_NAME."
  41. exit 4
  42. fi
  43. PKG_ARCH=@arch@
  44. ARCH=$(arch)
  45. if [ $ARCH == "i386" ] || [ $ARCH == "i586" ] || [ $ARCH == "i686" ]; then
  46. ARCH=x86
  47. fi
  48. if [[ $ARCH != $PKG_ARCH ]]; then
  49. echo "$PKG_ARCH $PKG_NAME can not be installed on $ARCH platform."
  50. exit 4
  51. fi
  52. PATH=/usr/bin:/bin
  53. umask 022
  54. PSWPKG=`mktemp -t sgx-psw-pkg.XXXXXX`
  55. PSW_TEMP_FOLDER=`mktemp -d sgx-psw-XXXXXX -p /tmp`
  56. trap "rm -fr $PSWPKG $PSW_TEMP_FOLDER= 2>/dev/null; exit 3" HUP INT QUIT TERM
  57. # The number of lines in this script (plus 1). Using this number to
  58. # calculate the start address of the payload.
  59. NR_SCRIPT_LINES=@linenum@
  60. # Run /usr/bin/md5sum on the binary payload to get the MD5 check sum.
  61. CHKSUM=@md5sum@
  62. # Get the install payload from this shell script.
  63. echo -n "Unpacking $PKG_NAME ..."
  64. tail -n +$NR_SCRIPT_LINES "$0" > $PSWPKG
  65. echo " done."
  66. echo -n "Verifying the integrity of the install package ..."
  67. if test $(md5sum $PSWPKG | awk '{print $1}') != $CHKSUM; then
  68. echo " The install package appears to be corrupted."
  69. exit 1
  70. fi
  71. echo " done."
  72. echo -n "Installing $PKG_NAME ..."
  73. tar zxf $PSWPKG -C $PSW_TEMP_FOLDER >/dev/null 2>&1
  74. retcode=$? # Save the return code
  75. # Clean-up the temporary tarball.
  76. rm -f $PSWPKG 2>/dev/null
  77. if test $retcode -ne 0; then
  78. echo " failed."
  79. exit 2
  80. fi
  81. pushd $PSW_TEMP_FOLDER
  82. source scripts/installConfig
  83. make install
  84. popd
  85. ${SGX_PACKAGES_PATH}/${PSW_PKG_NAME}/scripts/install.sh
  86. rm -fr ${PSW_TEMP_FOLDER}
  87. exit 0